// classe piximage
class piximage {

  PImage im;
  PImage jacquard;
  int largeur_rang=8;

  color couleur;
  float luminosite;
  float bleu;
  float rouge;
  float vert;
  

  int im_x;
  int im_y;

  int x=0;
  int y=0;

  float l, h;
  float ratio;
  float multiplicateur;



  piximage(String source, int x, int y, int largeur, int hauteur) {
    im=loadImage(source);
    this.im_x=x;
    this.im_y=y;

    creer_jacquard();

    println (im.width+" " +im.height);
    // calcul de l'image d'après les proportions données
    ratio=(largeur*1.0) / hauteur;
    float ratioi=(im.width*1.0)/im.height;

    println(ratio + " et " + ratioi);
    if (ratio >= ratioi) {
      println("ratio superieur");
      l=float(hauteur)*ratioi;
      h=hauteur;
      multiplicateur=(largeur*1.0)/im.height;
    } else {
      println("ratio inferieur");
      l=largeur;
      h=float(largeur)/ratioi;
      multiplicateur=(largeur*1.0)/im.width;
    }

    println(l + " / " + h);
    println("multiplicateur "+multiplicateur);
  }

  void afficher() {
    // afficher l'iage
    image(im, im_x, im_y, l, h);

    // afficher le rectangle de suivi
    fill(0, 255, 0, 150);
    rect(im_x+(x*multiplicateur)-1, im_y+(y*multiplicateur)-1, multiplicateur+2, multiplicateur+2);
  }

  void afficher_progression() {
    image(jacquard, im_x, im_y, l, h);
    // afficher le rectangle de suivi
    fill(0, 255, 0, 150);
    rect(im_x+(x*multiplicateur)-1, im_y+(y*multiplicateur)-1, (l)+2, multiplicateur+2);
  }
  
  void afficher_rang(int ax,int ay, int aw, int ah){
    for(int p=0;p<largeur_rang;p++){
      color c=jacquard.get(p,y);
      fill(c);
      rect(ax+p*(aw/largeur_rang),ay,aw/largeur_rang,ah);
    }
  }

  void next_pix() {
    x+=1;
    if (x>=im.width) {
      x=0;
      y+=1;
      if (y>=im.height) {
        y=0;
        println("fin de l'image, retour au début");
      }
    }
    sample_pixel();
  }

  float pixel(int position) {
    color c=jacquard.get(position, y);
    return brightness(c);
  }

  void next_row() {
    y+=1;
    if (y>=im.height) {
      y=0;
      println("fin de l'image, retour au début");
    }
    sample_pixel();
  }

  void creer_jacquard() {
    PGraphics r;
    r=createGraphics(largeur_rang, im.height);
    r.beginDraw();
    r.background(255);
    r.image(im, 0, 0, largeur_rang, im.height);
    r.endDraw();
    r.save("rang.tif");
    jacquard=loadImage("rang.tif");
  }

  void sample_pixel() {
    color c=im.get(x, y);
    rouge = c >> 16 & 0xFF;
    vert = c >> 8 & 0xFF;
    bleu = c & 0xFF;
    luminosite=brightness(c);
  }
}