String image_source="200_s.gif"; // le nom de l'image à placer dans le dossier

import ddf.minim.*;
import ddf.minim.ugens.*;

Minim minim;
AudioOutput out;
String[] notes= {
  "A3", "B3", "C3", "D3", "E3", "F3", "G3", 
  "A4", "B4", "C4", "D4", "E4", "F4", "G4", 
  "A5", "B5", "C5", "D5", "E5", "F5", "G5"
};

piximage i;
int trigger;

int duration = 200;

void setup() {
  size(700, 700);
  i=new piximage(image_source, 10, 10, width-20, height-20);

  minim = new Minim(this);
  // use the getLineOut method of the Minim object to get an AudioOutput object
  out = minim.getLineOut();
  out.setTempo( 80 );

  trigger = millis();
}

void draw() {
  if (millis() > trigger) {
    background(0);
    i.afficher();
    i.next_pix();

    int note=int(map(i.bleu+i.vert+i.rouge, 0, 755, 0, notes.length));
    out.playNote( notes[note] );

    affiche_stats(20, 200);
    trigger = millis() + duration;
  }
}